PROGRAM average_grid

  IMPLICIT NONE

  INTEGER, PARAMETER :: ngrid = 10
  INTEGER, DIMENSION(0:ngrid+1) :: imap
  REAL, DIMENSION(ngrid,ngrid) :: f_in,f_av
  REAL :: g,h
  INTEGER :: i,j,k,l

  open(99,file='grid.dat',status='old')
  open(98,file='avgrid.dat',status='unknown')
  do j=1,ngrid
    do i=1,ngrid
      read(99,*)f_in(i,j)
    end do
  end do
  close(99)

  do i=1,ngrid
    imap(i)=i
  end do
  imap(0)=ngrid
  imap(ngrid+1)=1


  do j=1,ngrid
    do i=1,ngrid
      f_av(i,j)=0.0
      h=0.0
      do l=-1,1
        do k=-1,1
          g=f_in(imap(i+k),imap(j+l))
          h=h+g
        end do
      end do
      f_av(i,j)=h/9.0
      write(98,*)f_av(i,j)
    end do
  end do

  close(98)

end PROGRAM average_grid
